from SystemUpdater.Core.GenericConfigParser import Gconfig
from SystemUpdater.Core.PluginManager import pluginManagerClass
from SystemUpdater.configs import settings
import logging

def check_pre_update_scripts():
    try:
        # 获取检查更新脚本是否已经执行，执行过时不需要重复执行，包括更新程序自升级完成后、其他应用等等
        executed = settings.get("pre_update_executed",False)
        if executed:
            logging.info("pre_update_scripts has executed and skip...")
        else:
            genericConfig = Gconfig()
            # 获取 script 字段，若不存在则返回空列表
            scripts = genericConfig.get("script", {})
            pre_update_scripts_list = scripts.get("pre_update_script",[])
            logging.info(f"pre_update scripts list is {pre_update_scripts_list}")
            for srcipt in pre_update_scripts_list:
                pluginManagerClass().run_plugin(srcipt)
            
            # 设置已执行并保存到配置文件中
            settings["pre_update_executed"] = True
    except Exception as e:
        logging.error("pre_update_scripts exec failed")
        logging.error(e)

def check_post_update_scripts():
    try:
        # 更新后脚本不需要判断是否已经执行，由于更新后脚本仅可能执行一遍，更新前脚本会递归调用造成重复执行的问题
        genericConfig = Gconfig()
        # 获取 script 字段，若不存在则返回空列表
        scripts = genericConfig.get("script", {})
        post_update_scripts_list = scripts.get("post_update_script",[])
        logging.info(f"pre_update scripts list is {post_update_scripts_list}")
        for srcipt in post_update_scripts_list:
            pluginManagerClass().run_plugin(srcipt)

        # 设置执行流程执行完毕，并保存到配置文件中
        settings["pre_update_executed"] = False
    except Exception as e:
        logging.error("post_update_scripts exec failed")
        logging.error(e)